section "code"  class_code
section "data"  class_data
section "data?" class_bss
section "idata" class_imports

STRUC GUID

    Data1                           dd ?
    Data2                           dw ?
    Data3                           dw ?
    Data4                           rb 8
    
ENDS



STRUC VSS_SNAPSHOT_PROP

    m_SnapshotId                    rs GUID,1
    m_SnapshotSetId                 rs GUID,1
    m_lSnapshotsCount               dd ?
    m_pwszSnapshotDeviceObject      dd ?
    m_pwszOriginalVolumeName        dd ?
    m_pwszOriginatingMachine        dd ?
    m_pwszServiceMachine            dd ?
    m_pwszExposedName               dd ?
    m_pwszExposedPath               dd ?
    m_ProviderId                    rs GUID,1
    m_lSnapshotAttributes           dd ?
    m_tsCreationTimestamp           dq ? 
    m_eStatus                       dd ?


ENDS



STRUCT IVssBackupComponents

    QueryInterface                  dd ?
    AddRef                          dd ?
    Release                         dd ?
    GetWriterComponentsCount        dd ?
    GetWriterComponents             dd ?
    InitializeForBackup             dd ?
    SetBackupState                  dd ?
    InitializeForRestore            dd ?
    SetRestoreState                 dd ?
    GatherWriterMetadata            dd ?
    GetWriterMetadataCount          dd ?
    GetWriterMetadata               dd ?
    FreeWriterMetadata              dd ?
    AddComponent                    dd ?
    PrepareForBackup                dd ?
    AbortBackup                     dd ?
    GatherWriterStatus              dd ?
    GetWriterStatusCount            dd ?
    FreeWriterStatus                dd ?
    GetWriterStatus                 dd ?
    SetBackupSucceeded              dd ?
    SetBackupOptions                dd ?
    SetSelectedForRestore           dd ?
    SetRestoreOptions               dd ?
    SetAdditionalRestores           dd ?
    SetPreviousBackupStamp          dd ?
    SaveAsXML                       dd ?
    BackupComplete                  dd ?
    AddAlternativeLocationMapping   dd ?
    AddRestoreSubcomponent          dd ?
    SetFileRestoreStatus            dd ?
    AddNewTarget                    dd ?
    SetRangesFilePath               dd ?
    PreRestore                      dd ?
    PostRestore                     dd ?
    SetContext                      dd ?
    StartSnapshotSet                dd ?
    AddToSnapshotSet                dd ?
    DoSnapshotSet                   dd ?
    DeleteSnapshots                 dd ?
    ImportSnapshots                 dd ?
    BreakSnapshotSet                dd ?
    GetSnapshotProperties           dd ?
    Query                           dd ?
    IsVolumeSupported               dd ?
    DisableWriterClasses            dd ?
    EnableWriterClasses             dd ?
    DisableWriterInstances          dd ?
    ExposeSnapshot                  dd ?
    RevertToSnapshot                dd ?
    QueryRevertStatus               dd ?

ENDS



STRUCT IVssAsync

    QueryInterface                  dd ?
    AddRef                          dd ?
    Release                         dd ?
    Cancel                          dd ?
    _Wait                           dd ?
    QueryStatus                     dd ?

ENDS



STRUC STARTUPINFO

  cb                                dd ?
  lpReserved                        dd ?
  lpDesktop                         dd ?
  lpTitle                           dd ?
  dwX                               dd ?
  dwY                               dd ?
  dwXSize                           dd ?
  dwYSize                           dd ?
  dwXCountChars                     dd ?
  dwYCountChars                     dd ?
  dwFillAttribute                   dd ?
  dwFlags                           dd ?
  wShowWindow                       dw ?
  cbReserved2                       dw ?
  lpReserved2                       dd ?
  hStdInput                         dd ?
  hStdOutput                        dd ?
  hStdError                         dd ?

ENDS



STRUC PROCESS_INFORMATION

  hProcess                          dd ?
  hThread                           dd ?
  dwProcessId                       dd ?
  dwThreadId                        dd ?

ENDS



RPC_C_AUTHN_LEVEL_CONNECT           equ 2
RPC_C_IMP_LEVEL_IMPERSONATE         equ 3
RPC_C_AUTHN_LEVEL_PKT_PRIVACY       equ 6
RPC_C_IMP_LEVEL_IDENTIFY            equ 2
EOAC_NONE                           equ 0
VSS_OBJECT_SNAPSHOT                 equ 3
VSS_BT_FULL                         equ 1
TRUE                                equ 1
FALSE                               equ 0
NULL                                equ 0
CP_ACP                              equ 0
COINIT_MULTITHREADED                equ 0
MB_PRECOMPOSED                      equ 1
DDD_REMOVE_DEFINITION               equ 2
NUMB_OF_REQ_CMDLINE_PARAMS          equ 4
INFINITE                            equ -1



MACRO coinvoke

MARG ppv :REQ,interface :REQ,member :REQ,params :VARARG

    FOR arg IN: params REV DO
    
        push arg

    ENDM

    mov     eax,[ppv]
    push    eax
    mov     eax,DWORD PTR [eax]
    call    [eax+&interface.&member]
    
ENDM



import_dll kernel32.dll

	import_func CloseHandle
	import_func CreateProcess alias CreateProcessA
	import_func DefineDosDevice alias DefineDosDeviceA
	import_func ExitProcess
	import_func GetCommandLine alias GetCommandLineA
	import_func GetStartupInfo alias GetStartupInfoA
	import_func GetStdHandle
	import_func MultiByteToWideChar
	import_func WaitForSingleObject
	import_func WideCharToMultiByte
	import_func WriteFile
	import_func lstrlen alias lstrlenA

import_dll ole32.dll

	import_func CoInitializeEx
	import_func CoInitializeSecurity
	import_func CoUninitialize

import_dll user32.dll

	import_func wsprintf CDECL alias wsprintfA

import_dll vssapi.dll

        import_func CreateVssBackupComponents alias ?CreateVssBackupComponents@@YGJPAPAVIVssBackupComponents@@@Z
	import_func VssFreeSnapshotProperties
